=== modified file 'shelf.py'
--- shelf.py	2005-08-25 01:51:22 +0000
+++ shelf.py	2005-09-29 16:19:07 +0000
@@ -7,6 +7,7 @@
 import tty, termios
 import glob
 from bzrlib.commands import Command
+from bzrlib.branch import Branch
 
 def main(args):
     name = os.path.basename(args.pop(0))
@@ -165,7 +166,17 @@
     takes_args = ['file*']
     takes_options = ['message', 'revision']
     def run(self, file_list=None, message=None, revision=None):
-        return shelve(message=message, file_list=file_list, revision=revision)
+        revision_list = None
+        if revision is not None and revision:
+            if file_list is not None and len(file_list) > 0:
+                branchdir = file_list[0]
+            else:
+                branchdir = '.'
+            b = Branch.open_containing(branchdir)
+            revision_list = ["revid:" + revision[0].in_history(b).rev_id]
+
+        return shelve(message=message, file_list=file_list, 
+                      revision=revision_list)
 
 class cmd_unshelve(Command):
     """Restore previously-shelved changes to the current tree.

